]> git.pld-linux.org Git - packages/lxc.git/blob - lxc-pld.in.sh
- up to 3.0.2; lua/python bindings now as separate packages
[packages/lxc.git] / lxc-pld.in.sh
1 #!/bin/sh
2
3 #
4 # template script for generating PLD Linux container for LXC
5 #
6
7 #
8 # lxc: Linux Container library
9
10 # Authors:
11 # Elan Ruusamäe <glen@pld-linux.org>
12
13 # This library is free software; you can redistribute it and/or
14 # modify it under the terms of the GNU Lesser General Public
15 # License as published by the Free Software Foundation; either
16 # version 2.1 of the License, or (at your option) any later version.
17
18 # This library is distributed in the hope that it will be useful,
19 # but WITHOUT ANY WARRANTY; without even the implied warranty of
20  # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
21 # Lesser General Public License for more details.
22
23 # You should have received a copy of the GNU Lesser General Public
24 # License along with this library; if not, write to the Free Software
25 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
26
27 # Configuration
28 arch=$(uname -m)
29 cache_base=@LOCALSTATEDIR@/cache/lxc/pld/$arch
30 default_path=@LXCPATH@
31 root_password=root
32
33 if [ -e /etc/os-release ]; then
34         # This is a shell friendly configuration file.  We can just source it.
35         # What we're looking for in here is the ID, VERSION_ID and the CPE_NAME
36         . /etc/os-release
37         echo "Host CPE ID from /etc/os-release: ${CPE_NAME}"
38 fi
39
40 if [ "${CPE_NAME}" != "" -a "${ID}" = "pld" -a "${VERSION_ID}" != "" ]; then
41         pld_host_ver=${VERSION_ID}
42         is_pld=true
43 elif [ -e /etc/pld-release ]; then
44         # Only if all other methods fail, try to parse the pld-release file.
45         pld_host_ver=$(sed -e '/PLD /!d' -e 's/^\([0-9.]*\)\sPLD.*/\1/' < /etc/pld-release)
46         if [ "$pld_host_ver" != "" ]; then
47                 is_pld=true
48         fi
49 fi
50
51 # Map a few architectures to their generic PLD Linux repository archs.
52 case "$pld_host_ver:$arch" in
53 3.0:i586) arch=i486 ;;
54 esac
55
56 configure_pld()
57 {
58
59         # disable selinux
60         mkdir -p $rootfs_path/selinux
61         echo 0 > $rootfs_path/selinux/enforce
62
63         # configure the network using the dhcp
64         sed -i -e "s/^HOSTNAME=.*/HOSTNAME=${utsname}/" ${rootfs_path}/etc/sysconfig/network
65
66         # set hostname on systemd
67         if [ $release = "3.0" ]; then
68                 echo "${utsname}" > ${rootfs_path}/etc/hostname
69         fi
70
71         # set minimal hosts
72         test -e $rootfs_path/etc/hosts || \
73         cat <<EOF > $rootfs_path/etc/hosts
74 127.0.0.1 localhost.localdomain localhost $utsname
75 ::1                 localhost6.localdomain6 localhost6
76 EOF
77
78         dev_path="${rootfs_path}/dev"
79         rm -rf $dev_path
80         mkdir -p $dev_path
81         mknod -m 666 ${dev_path}/null c 1 3
82         mknod -m 666 ${dev_path}/zero c 1 5
83         mknod -m 666 ${dev_path}/random c 1 8
84         mknod -m 666 ${dev_path}/urandom c 1 9
85         mkdir -m 755 ${dev_path}/pts
86         mkdir -m 1777 ${dev_path}/shm
87         mknod -m 666 ${dev_path}/tty c 5 0
88         mknod -m 666 ${dev_path}/tty0 c 4 0
89         mknod -m 666 ${dev_path}/tty1 c 4 1
90         mknod -m 666 ${dev_path}/tty2 c 4 2
91         mknod -m 666 ${dev_path}/tty3 c 4 3
92         mknod -m 666 ${dev_path}/tty4 c 4 4
93         mknod -m 600 ${dev_path}/console c 5 1
94         mknod -m 666 ${dev_path}/full c 1 7
95         mknod -m 600 ${dev_path}/initctl p
96         mknod -m 666 ${dev_path}/ptmx c 5 2
97
98         echo "setting root passwd to $root_password"
99         echo "root:$root_password" | chroot $rootfs_path chpasswd
100
101         return 0
102 }
103
104 configure_pld_init()
105 {
106         # default powerfail action waits 2 minutes. for lxc we want it immediately
107         sed -i -e '/^pf::powerfail:/ s,/sbin/shutdown.*,/sbin/halt,' ${rootfs_path}/etc/inittab
108 }
109
110 configure_pld_systemd()
111 {
112         unlink ${rootfs_path}/etc/systemd/system/default.target
113         chroot ${rootfs_path} ln -s /dev/null /etc/systemd/system/udev.service
114         chroot ${rootfs_path} ln -s /lib/systemd/system/multi-user.target /etc/systemd/system/default.target
115
116         # Actually, the After=dev-%i.device line does not appear in the
117         # Fedora 17 or Fedora 18 systemd getty@.service file. It may be left
118         # over from an earlier version and it's not doing any harm. We do need
119         # to disable the "ConditionalPathExists=/dev/tty0" line or no gettys are
120         # started on the ttys in the container. Lets do it in an override copy of
121         # the service so it can still pass rpm verifies and not be automatically
122         # updated by a new systemd version.  --  mhw  /\/\|=mhw=|\/\/
123
124         sed -e 's/^ConditionPathExists=/# ConditionPathExists=/' \
125                 -e 's/After=dev-%i.device/After=/' \
126         < ${rootfs_path}/lib/systemd/system/getty@.service \
127         > ${rootfs_path}/etc/systemd/system/getty@.service
128
129         # Setup getty service on the 4 ttys we are going to allow in the
130         # default config. Number should match lxc.tty
131         for i in 1 2 3 4; do
132                 ln -sf ../getty@.service ${rootfs_path}/etc/systemd/system/getty.target.wants/getty@tty${i}.service
133         done
134 }
135
136 download_pld()
137 {
138
139         # check the mini pld was not already downloaded
140         INSTALL_ROOT=$cache/partial
141         mkdir -p $INSTALL_ROOT
142         if [ $? -ne 0 ]; then
143                 echo "Failed to create '$INSTALL_ROOT' directory"
144                 return 1
145         fi
146
147         # download a mini pld into a cache
148         echo "Downloading PLD Linux minimal ..."
149         POLDEK="poldek --root $INSTALL_ROOT --noask --nohold --noignore"
150         PKG_LIST="basesystem filesystem pld-release rpm poldek vserver-packages rc-scripts pwdutils mingetty"
151
152         mkdir -p $INSTALL_ROOT@LOCALSTATEDIR@/lib/rpm
153         rpm --root $INSTALL_ROOT --initdb
154         $POLDEK -u $PKG_LIST
155
156         if [ $? -ne 0 ]; then
157                 echo "Failed to download the rootfs, aborting."
158                 return 1
159         fi
160
161         mv "$INSTALL_ROOT" "$cache/rootfs"
162         echo "Download complete."
163
164         return 0
165 }
166
167 copy_pld()
168 {
169
170         # make a local copy of the minipld
171         echo -n "Copying rootfs to $rootfs_path ..."
172         cp -a $cache/rootfs/* $rootfs_path || return 1
173         return 0
174 }
175
176 update_pld()
177 {
178         POLDEK="poldek --root $cache/rootfs --noask"
179         $POLDEK --upgrade-dist
180 }
181
182 install_pld()
183 {
184         mkdir -p @LOCALSTATEDIR@/lock/subsys/
185         (
186                 flock -x 9
187                 if [ $? -ne 0 ]; then
188                         echo "Cache repository is busy."
189                         return 1
190                 fi
191
192                 echo "Checking cache download in $cache/rootfs ... "
193                 if [ ! -e "$cache/rootfs" ]; then
194                         download_pld
195                         if [ $? -ne 0 ]; then
196                                 echo "Failed to download 'pld base'"
197                                 return 1
198                         fi
199                 else
200                         echo "Cache found. Updating..."
201                         update_pld
202                         if [ $? -ne 0 ]; then
203                                 echo "Failed to update 'pld base', continuing with last known good cache"
204                         else
205                                 echo "Update finished"
206                         fi
207                 fi
208
209                 echo "Copy $cache/rootfs to $rootfs_path ... "
210                 copy_pld
211                 if [ $? -ne 0 ]; then
212                         echo "Failed to copy rootfs"
213                         return 1
214                 fi
215
216                 return 0
217         ) 9>@LOCALSTATEDIR@/lock/subsys/lxc-pld
218
219         return $?
220 }
221
222 copy_configuration()
223 {
224
225         mkdir -p $config_path
226         grep -q "^lxc.rootfs" $config_path/config 2>/dev/null || echo "lxc.rootfs = $rootfs_path" >> $config_path/config
227         cat <<EOF >> $config_path/config
228 # Most of below settings should be taken as defaults  from
229 # lxc.include = /usr/share/lxc/config/common.conf
230 lxc.utsname = $utsname
231 lxc.tty = 4
232 lxc.pts = 1024
233 # Consider if below line is right for systemd container
234 lxc.mount = $config_path/fstab
235 lxc.cap.drop = sys_module mac_admin mac_override sys_time
236
237 lxc.autodev = $auto_dev
238
239 # When using LXC with apparmor, uncomment the next line to run unconfined:
240 #lxc.aa_profile = unconfined
241
242 ## Devices
243 # Allow all devices
244 #lxc.cgroup.devices.allow = a
245 # Deny all devices
246 lxc.cgroup.devices.deny = a
247 # Allow to mknod all devices (but not using them)
248 lxc.cgroup.devices.allow = c *:* m
249 lxc.cgroup.devices.allow = b *:* m
250
251 # /dev/null and zero
252 lxc.cgroup.devices.allow = c 1:3 rwm
253 lxc.cgroup.devices.allow = c 1:5 rwm
254 # consoles
255 lxc.cgroup.devices.allow = c 5:1 rwm
256 lxc.cgroup.devices.allow = c 5:0 rwm
257 lxc.cgroup.devices.allow = c 4:0 rwm
258 lxc.cgroup.devices.allow = c 4:1 rwm
259 # /dev/{,u}random
260 lxc.cgroup.devices.allow = c 1:9 rwm
261 lxc.cgroup.devices.allow = c 1:8 rwm
262 lxc.cgroup.devices.allow = c 136:* rwm
263 lxc.cgroup.devices.allow = c 5:2 rwm
264 # rtc
265 lxc.cgroup.devices.allow = c 254:0 rm
266 EOF
267
268         cat <<EOF > $config_path/fstab
269 proc            proc         proc    nodev,noexec,nosuid 0 0
270 sysfs           sys          sysfs defaults  0 0
271 EOF
272         if [ $? -ne 0 ]; then
273                 echo "Failed to add configuration"
274                 return 1
275         fi
276
277         return 0
278 }
279
280 clean()
281 {
282
283         if [ ! -e $cache ]; then
284                 exit 0
285         fi
286
287         # lock, so we won't purge while someone is creating a repository
288         (
289                 flock -x 9
290                 if [ $? != 0 ]; then
291                         echo "Cache repository is busy."
292                         exit 1
293                 fi
294
295                 echo -n "Purging the download cache for PLD Linux $release..."
296                 rm --preserve-root --one-file-system -rf $cache && echo "Done." || exit 1
297                 exit 0
298         ) 9>@LOCALSTATEDIR@/lock/subsys/lxc-pld
299 }
300
301 usage()
302 {
303         cat <<EOF
304 usage:
305         $1 -n|--name=<container_name>
306                 [-p|--path=<path>] [-c|--clean] [-R|--release=<PLD Release>] [--fqdn=<network name of container>] [-A|--arch=<arch of the container>]
307                 [-h|--help]
308 Mandatory args:
309   -n,--name         container name, used to as an identifier for that container from now on
310 Optional args:
311   -p,--path         path to where the container will be created, defaults to @LXCPATH@. The container config will go under @LXCPATH@ in that case
312   --rootfs          path for actual rootfs.
313   -c,--clean        clean the cache
314   -R,--release      PLD Linux release for the new container. if the host is PLD Linux, then it will default to the host's release.
315          --fqdn         fully qualified domain name (FQDN) for DNS and system naming
316   -A,--arch         NOT USED YET. Define what arch the container will be [i686,x86_64]
317   -h,--help         print this help
318 EOF
319         return 0
320 }
321
322 options=$(getopt -o hp:n:cR: -l help,path:,rootfs:,name:,clean,release:,fqdn: -- "$@")
323 if [ $? -ne 0 ]; then
324         usage $(basename $0)
325         exit 1
326 fi
327 eval set -- "$options"
328
329 while :; do
330         case "$1" in
331                 -h|--help)      usage $0 && exit 0;;
332                 -p|--path)      path=$2; shift 2;;
333                 --rootfs)       rootfs=$2; shift 2;;
334                 -n|--name)      name=$2; shift 2;;
335                 -c|--clean)     clean=$2; shift 2;;
336                 -R|--release)   release=$2; shift 2;;
337                 --fqdn)         utsname=$2; shift 2;;
338                 --)             shift 1; break ;;
339                 *)              break ;;
340         esac
341 done
342
343 if [ ! -z "$clean" -a -z "$path" ]; then
344         clean || exit 1
345         exit 0
346 fi
347
348 if [ -z "${utsname}" ]; then
349         utsname=${name}
350 fi
351
352 # This follows a standard "resolver" convention that an FQDN must have
353 # at least two dots or it is considered a local relative host name.
354 # If it doesn't, append the dns domain name of the host system.
355 #
356 # This changes one significant behavior when running
357 # "lxc_create -n Container_Name" without using the
358 # --fqdn option.
359 #
360 # Old behavior:
361 #    utsname and hostname = Container_Name
362 # New behavior:
363 #    utsname and hostname = Container_Name.Domain_Name
364
365 if [ $(expr "$utsname" : '.*\..*\.') = 0 ]; then
366         if [ -n "$(dnsdomainname)" ]; then
367                 utsname=${utsname}.$(dnsdomainname)
368         fi
369 fi
370
371 needed_pkgs=""
372 type poldek >/dev/null 2>&1
373 if [ $? -ne 0 ]; then
374         needed_pkgs="poldek $needed_pkgs"
375 fi
376
377 #type curl >/dev/null 2>&1
378 #if [ $? -ne 0 ]; then
379 #       needed_pkgs="curl $needed_pkgs"
380 #fi
381
382 if [ -n "$needed_pkgs" ]; then
383         echo "Missing commands: $needed_pkgs"
384         echo "Please install these using \"sudo poldek -u $needed_pkgs\""
385         exit 1
386 fi
387
388 if [ -z "$path" ]; then
389         path=$default_path/$name
390 fi
391
392 if [ -z "$release" ]; then
393         if [ "$is_pld" -a "$pld_host_ver" ]; then
394                 release=$pld_host_ver
395         else
396                 echo "This is not a PLD Linux host and release missing, defaulting to 3.0. use -R|--release to specify release"
397                 release=3.0
398         fi
399 fi
400
401 # pld th have systemd. We need autodev enabled to keep systemd from causing problems.
402 if [ $release = 3.0 ]; then
403         auto_dev="0"
404 else
405         auto_dev="0"
406 fi
407
408 if [ "$(id -u)" != "0" ]; then
409         echo "This script should be run as 'root'"
410         exit 1
411 fi
412
413 if [ -z "$rootfs" ]; then
414     rootfs_path=$path/rootfs
415     # check for 'lxc.rootfs' passed in through default config by lxc-create
416     # TODO: should be lxc.rootfs.mount used instead?
417     if grep -q '^lxc.rootfs' $path/config 2>/dev/null ; then
418             rootfs_path=$(awk -F= '/^lxc.rootfs =/{ print $2 }' $path/config)
419     fi
420 else
421     rootfs_path=$rootfs
422 fi
423 config_path=$default_path/$name
424 cache=$cache_base/$release
425
426 revert()
427 {
428         echo "Interrupted, so cleaning up"
429         lxc-destroy -n $name
430         # maybe was interrupted before copy config
431         rm -rf $path
432         rm -rf $default_path/$name
433         echo "exiting..."
434         exit 1
435 }
436
437 trap revert SIGHUP SIGINT SIGTERM
438
439 copy_configuration
440 if [ $? -ne 0 ]; then
441         echo "Failed write configuration file"
442         exit 1
443 fi
444
445 install_pld
446 if [ $? -ne 0 ]; then
447         echo "Failed to install PLD Linux"
448         exit 1
449 fi
450
451 configure_pld
452 if [ $? -ne 0 ]; then
453         echo "Failed to configure PLD Linux for a container"
454         exit 1
455 fi
456
457 # If the systemd configuration directory exists - set it up for what we need.
458 if [ -d ${rootfs_path}/etc/systemd/system ]; then
459         configure_pld_systemd
460 fi
461
462 # This configuration (rc.sysinit) is not inconsistent with the systemd stuff
463 # above and may actually coexist on some upgraded systems. Let's just make
464 # sure that, if it exists, we update this file, even if it's not used...
465 if [ -f ${rootfs_path}/etc/rc.sysinit ]; then
466         configure_pld_init
467 fi
468
469 if [ ! -z $clean ]; then
470         clean || exit 1
471         exit 0
472 fi
473 echo "container rootfs and config created"
This page took 0.055393 seconds and 3 git commands to generate.